=== debian/changelog ===
gvm-libs (22.20.0-1build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 08:15:25 +0200

gvm-libs (22.20.0-1) unstable; urgency=medium

  * New upstream version 22.20.0
  * Refresh patches
  * Update symbols
  * Update lintian-overrides

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 08 Apr 2025 16:35:36 +0200

gvm-libs (22.18.1-1) unstable; urgency=medium

  * New upstream version 22.18.1
  * Update debian/copyright
  * Refresh patches
  * Update symbols
  * Bump Standards-Version to 4.7.2 (no changes)

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 21 Mar 2025 15:25:26 +0100

gvm-libs (22.16.0-1) unstable; urgency=medium

  * New upstream version 22.16.0
  * Refresh patches
  * Add new build-dep libcurl4-gnutls-dev
  * Update symbols
  * Update lintian-overrides

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 24 Jan 2025 13:58:02 +0100
